Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/breadcrumbs.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/breadcrumbs.py	(revision 6917)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/breadcrumbs.py	(revision 6918)
@@ -6,8 +6,9 @@
 from zope.publisher.browser import TestRequest
 
-from waeup.sirp.interfaces import IConfigurationContainer
+from waeup.sirp.interfaces import (
+    IConfigurationContainer, ISessionConfiguration)
 from waeup.sirp.browser import interfaces
-from waeup.sirp.browser.interfaces import (IBreadcrumb, IBreadcrumbIgnorable,
-                                      IBreadcrumbContainer)
+from waeup.sirp.browser.interfaces import (IBreadcrumb,
+    IBreadcrumbIgnorable, IBreadcrumbContainer)
         
 class Breadcrumb(grok.Adapter):
@@ -108,4 +109,15 @@
     parent_viewname = 'administration'
 
+class SessionConfigurationBreadcrumb(Breadcrumb):
+    """A breadcrumb for the configuration container.
+    """
+    grok.context(ISessionConfiguration)
+    title = u'Portal Session Configuration'
+
+    @property
+    def title(self):
+        session_string = self.context.getSessionString()
+        return 'Session %s' % session_string
+
 class UserContainerBreadcrumb(Breadcrumb):
     """A breadcrumb for user containers.
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 6917)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 6918)
@@ -489,6 +489,6 @@
         for key, val in self.context.items():
             url = self.url(val)
-            session_string = academic_sessions_vocab.getTermByToken(key).title
-            title = 'Session %s Configuration Data' % session_string
+            session_string = val.getSessionString()
+            title = 'Session %s Configuration' % session_string
             yield(dict(url=url, name=key, title=title))
 
@@ -531,4 +531,35 @@
     def cancel(self):
         self.redirect(self.url(self.context, '@@index')+'#tab-2')
+        return
+
+class SessionConfigurationManageFormPage(WAeUPEditFormPage):
+    """Manage session configuration object.
+    """
+    grok.context(ISessionConfiguration)
+    grok.name('index')
+    grok.require('waeup.managePortalConfiguration')
+    form_fields = grok.AutoFields(ISessionConfiguration)
+    pnav = 0
+
+    @property
+    def title(self):
+        session_string = self.context.getSessionString()
+        return 'Academic Session %s Configuration' % session_string
+
+    @property
+    def label(self):
+        session_string = self.context.getSessionString()
+        return 'Edit academic session %s configuration' % session_string
+
+    @grok.action('Save')
+    def save(self, **data):
+        self.applyData(self.context, **data)
+        self.flash('Settings have been saved.')
+        self.redirect(self.url(self.context.__parent__, '@@index')+'#tab-2')
+        return
+
+    @grok.action('Cancel', validator=NullValidator)
+    def cancel(self):
+        self.redirect(self.url(self.context.__parent__, '@@index')+'#tab-2')
         return
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/configuration.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/configuration.py	(revision 6917)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/configuration.py	(revision 6918)
@@ -20,5 +20,6 @@
 from zope.component.interfaces import IFactory
 from waeup.sirp.interfaces import (
-    ISessionConfiguration, IConfigurationContainer, ISessionConfigurationAdd)
+    ISessionConfiguration, IConfigurationContainer, ISessionConfigurationAdd,
+    academic_sessions_vocab)
 from waeup.sirp.utils.helpers import attrs_to_fields
 
@@ -49,4 +50,7 @@
     grok.implements(ISessionConfiguration, ISessionConfigurationAdd)
 
+    def getSessionString(self):
+        return academic_sessions_vocab.getTerm(self.academic_session).title
+
 SessionConfiguration = attrs_to_fields(SessionConfiguration)
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 6917)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 6918)
@@ -249,4 +249,9 @@
         )
 
+    def getSessionString():
+        """Returns the session string from the vocabulary.
+        """
+
+
 class ISessionConfigurationAdd(ISessionConfiguration):
     """A session configuration object in add mode.