Index: main/waeup.custom/trunk/src/waeup/custom/configuration.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/configuration.py	(revision 6923)
+++ main/waeup.custom/trunk/src/waeup/custom/configuration.py	(revision 6923)
@@ -0,0 +1,30 @@
+"""
+Containers for session configuration objects.
+"""
+import grok
+from zope.interface import implementedBy
+from waeup.sirp.utils.helpers import attrs_to_fields
+from waeup.sirp.configuration import (
+    SessionConfigurationFactory, SessionConfiguration)
+from waeup.custom.interfaces import (
+    ISessionConfiguration, ISessionConfigurationAdd)
+
+
+class SessionConfiguration(SessionConfiguration):
+    """
+    Customized session configuration model
+    """
+
+    grok.implements(ISessionConfiguration, ISessionConfigurationAdd)
+
+SessionConfiguration = attrs_to_fields(SessionConfiguration)
+
+class SessionConfigurationFactory(SessionConfigurationFactory):
+    """A customized factory for session configuration objects.
+    """
+
+    def __call__(self, *args, **kw):
+        return SessionConfiguration(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(SessionConfiguration)
Index: main/waeup.custom/trunk/src/waeup/custom/interfaces.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 6923)
+++ main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 6923)
@@ -0,0 +1,66 @@
+##
+## interfaces.py
+from zope import schema
+from waeup.sirp.interfaces import IWAeUPObject, academic_sessions_vocab
+
+class ISessionConfiguration(IWAeUPObject):
+    """A session configuration object.
+    """
+
+    academic_session = schema.Choice(
+        title = u'Academic Session',
+        source = academic_sessions_vocab,
+        default = None,
+        required = True,
+        readonly = True
+        )
+
+    fee_1 = schema.Int(
+        title = u'School Fee',
+        default = 0,
+        )
+
+    surcharge_1 = schema.Int(
+        title = u'Surcharge BT',
+        default = 0,
+        )
+
+    surcharge_2 = schema.Int(
+        title = u'Surcharge Interswitch',
+        default = 0,
+        )
+
+    gown = schema.Int(
+        title = u'Gown Fee',
+        default = 0,
+        )
+
+    transfer = schema.Int(
+        title = u'Transfer Fee',
+        default = 0,
+        )
+
+    hostelmaintenance = schema.Int(
+        title = u'Hostel Maintenance Fee',
+        default = 0,
+        )
+
+    def getSessionString():
+        """Returns the session string from the vocabulary.
+        """
+
+
+class ISessionConfigurationAdd(ISessionConfiguration):
+    """A session configuration object in add mode.
+    """
+
+    academic_session = schema.Choice(
+        title = u'Academic Session',
+        source = academic_sessions_vocab,
+        default = None,
+        required = True,
+        readonly = False,
+        )
+
+ISessionConfigurationAdd['academic_session'].order =  ISessionConfiguration[
+    'academic_session'].order
Index: main/waeup.custom/trunk/src/waeup/custom/tests/__init__.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/tests/__init__.py	(revision 6923)
+++ main/waeup.custom/trunk/src/waeup/custom/tests/__init__.py	(revision 6923)
@@ -0,0 +1,2 @@
+# This is a package
+
Index: main/waeup.custom/trunk/src/waeup/custom/tests/test_configuration.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/tests/test_configuration.py	(revision 6923)
+++ main/waeup.custom/trunk/src/waeup/custom/tests/test_configuration.py	(revision 6923)
@@ -0,0 +1,74 @@
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""Tests for configuration containers and related.
+"""
+from zope.component.interfaces import IFactory
+from zope.interface import verify
+from waeup.sirp.testing import FunctionalLayer, FunctionalTestCase
+from waeup.sirp.configuration import ConfigurationContainer
+from waeup.sirp.interfaces import IConfigurationContainer
+from waeup.sirp.tests.test_configuration import (
+    ConfigurationTest, SessionConfigurationFactoryTest)
+from waeup.custom.configuration import (
+    SessionConfiguration, SessionConfigurationFactory)
+from waeup.custom.interfaces import(
+    ISessionConfiguration, ISessionConfigurationAdd)
+
+
+class ConfigurationTest(ConfigurationTest):
+
+    layer = FunctionalLayer
+
+    def setUp(self):
+        super(ConfigurationTest, self).setUp()
+        self.confcontainer = ConfigurationContainer()
+        self.sessionconf = SessionConfiguration()
+        return
+
+    #def tearDown(self):
+    #    super(ConfigurationTest, self).tearDown()
+    #    return
+
+    def test_interfaces(self):
+        #verify.verifyClass(IConfigurationContainer, ConfigurationContainer)
+        #verify.verifyObject(IConfigurationContainer, self.confcontainer)
+        verify.verifyClass(ISessionConfiguration, SessionConfiguration)
+        verify.verifyObject(ISessionConfiguration, self.sessionconf)
+        verify.verifyClass(ISessionConfigurationAdd, SessionConfiguration)
+        verify.verifyObject(ISessionConfigurationAdd, self.sessionconf)
+
+class SessionConfigurationFactoryTest(SessionConfigurationFactoryTest):
+
+    layer = FunctionalLayer
+
+    def setUp(self):
+        super(SessionConfigurationFactoryTest, self).setUp()
+        self.factory = SessionConfigurationFactory()
+
+    #def tearDown(self):
+    #    super(SessionConfigurationFactoryTest, self).tearDown()
+
+    def test_interfaces(self):
+        verify.verifyClass(IFactory, SessionConfigurationFactory)
+        verify.verifyObject(IFactory, self.factory)
+
+    def test_factory(self):
+        obj = self.factory()
+        assert isinstance(obj, SessionConfiguration)
+
+    def test_getInterfaces(self):
+        implemented_by = self.factory.getInterfaces()
+        assert implemented_by.isOrExtends(ISessionConfiguration)