Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6942)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6943)
@@ -50,8 +50,12 @@
 from waeup.sirp.authentication import get_principal_role_manager
 
+def write_log_message(view, message):
+    ob_class = view.__implemented__.__name__.replace('waeup.sirp.','')
+    view.context.getStudent().loggerInfo(ob_class, message)
+    return
+
 # Save function used for save methods in manager pages
 def msave(view, **data):
     form = view.request.form
-    ob_class = view.__implemented__.__name__.replace('waeup.sirp.','')
     changed_fields = view.applyData(view.context, **data)
     # Turn list of lists into single list
@@ -62,5 +66,5 @@
     view.flash('Form has been saved.')
     if fields_string:
-        view.context.getStudent().loggerInfo(ob_class, 'saved: % s' % fields_string)
+        write_log_message(view, 'saved: % s' % fields_string)
     return
 
@@ -366,5 +370,4 @@
     def save(self, **data):
         form = self.request.form
-        ob_class = self.__implemented__.__name__.replace('waeup.sirp.','')
         password = form.get('password', None)
         password_ctl = form.get('control_password', None)
@@ -376,5 +379,5 @@
                 #      are no (other) errors left in form.
                 IUserAccount(self.context).setPassword(password)
-                self.context.loggerInfo(ob_class, 'password changed')
+                write_log_message(self, 'password changed')
 
         #self.reg_number = form.get('form.reg_number', None)
@@ -403,5 +406,5 @@
         self.flash('Form has been saved.')
         if fields_string:
-            self.context.loggerInfo(ob_class, 'saved: % s' % fields_string)
+            write_log_message(self, 'saved: % s' % fields_string)
         return
 
@@ -772,29 +775,29 @@
 
 # We don't need the display form page yet
-class PaymentsDisplayFormPage(WAeUPDisplayFormPage):
-    """ Page to display the student payments
-    """
-    grok.context(IStudentPaymentsContainer)
-    grok.name('view')
-    grok.require('waeup.viewStudent')
-    form_fields = grok.AutoFields(IStudentPaymentsContainer)
-    grok.template('paymentspage')
-    title = 'Payments'
-    pnav = 4
-
-    def formatDatetime(self,datetimeobj):
-        if isinstance(datetimeobj, datetime):
-            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
-        else:
-            return None
-
-    @property
-    def label(self):
-        return '%s: Payments' % self.context.__parent__.fullname
-
-    def update(self):
-        super(PaymentsDisplayFormPage, self).update()
-        datatable.need()
-        return
+#class PaymentsDisplayFormPage(WAeUPDisplayFormPage):
+#    """ Page to display the student payments
+#    """
+#    grok.context(IStudentPaymentsContainer)
+#    grok.name('view')
+#    grok.require('waeup.viewStudent')
+#    form_fields = grok.AutoFields(IStudentPaymentsContainer)
+#    grok.template('paymentspage')
+#    title = 'Payments'
+#    pnav = 4
+
+#    def formatDatetime(self,datetimeobj):
+#        if isinstance(datetimeobj, datetime):
+#            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
+#        else:
+#            return None
+
+#    @property
+#    def label(self):
+#        return '%s: Payments' % self.context.__parent__.fullname
+
+#    def update(self):
+#        super(PaymentsDisplayFormPage, self).update()
+#        datatable.need()
+#        return
 
 # This manage form page is for both students and students officers.
@@ -853,4 +856,5 @@
         if len(deleted):
             self.flash('Successfully removed: %s' % ', '.join(deleted))
+            write_log_message(self,'removed: % s' % ', '.join(deleted))
         self.redirect(self.url(self.context))
         return
@@ -936,4 +940,5 @@
     def update(self):
         student = self.context.getStudent()
+        write_log_message(self,'valid callback: %s' % self.context.p_id)
         self.context.r_amount_approved = self.context.amount_auth
         self.context.r_card_num = u'0000'