Index: /WAeUP_SRP/trunk/skins/waeup_futminna/goto_interswitch_form_accept.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/goto_interswitch_form_accept.pt	(revision 6955)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/goto_interswitch_form_accept.pt	(revision 6955)
@@ -0,0 +1,59 @@
+<metal:body use-macro="here/main_template/macros/master">
+    <metal:main fill-slot="main"
+                tal:define="info options/info">
+                
+        <h3>Authorize Online Payment! </h3>
+        <br />
+                
+      <form method="post" action="pay_online"
+            tal:attributes="action info/action ">
+      <span tal:repeat="arg python:info['args'].items()"
+            tal:omit-tag="">
+          <input type="hidden" tal:attributes="name python:arg[0];value python:arg[1]" />
+      </span>          
+      
+      <span tal:replace = "structure info/xml_data" /> 
+      
+        <table>
+          <tr>
+            <td width="100px">
+            Payment:</td>
+            <td tal:content="info/type_description"></td>
+          </tr>
+          <tr>
+            <td>
+            Name:
+            </td>
+            <td tal:content="info/pay_bill_to" />
+          </tr>
+                         
+          <tr tal:condition="info/fee|nothing">
+            <td>
+            Fee:
+            </td>
+            <td> Naira <span tal:content="info/fee" /></td>
+          </tr>          
+          <tr>
+            <td >
+            Amount:
+            </td>
+            <td> Naira <span tal:content="info/amount" /></td>
+          </tr>
+          <tr tal:condition="info/surcharge|nothing">
+            <td >
+            Surcharge:
+            </td>
+            <td> Naira <span tal:content="info/surcharge" /></td>
+          </tr>             
+      
+        </table>
+        <br />
+        <input type="submit" 
+               class="standalone" 
+               name="goto_bank" 
+               value="Proceed to Interswitch Payment Gateway" 
+               />
+      </form>
+    </metal:main>
+</metal:body>
+
Index: /WAeUP_SRP/trunk/skins/waeup_futminna/interswitch_form_accept.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/interswitch_form_accept.pt	(revision 6954)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/interswitch_form_accept.pt	(revision 6955)
@@ -35,7 +35,13 @@
           <tr>
             <td >
-            Total Amount:
+            Amount:
             </td>
             <td> Naira <span tal:content="info/amount" /></td>
+          </tr>
+          <tr>
+            <td >
+            Surcharge:
+            </td>
+            <td> Naira <span tal:content="info/surcharge" /></td>
           </tr>
         </table>
Index: /WAeUP_SRP/trunk/skins/waeup_futminna/pay_interswitch_accept.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_futminna/pay_interswitch_accept.py	(revision 6954)
+++ /WAeUP_SRP/trunk/skins/waeup_futminna/pay_interswitch_accept.py	(revision 6955)
@@ -70,6 +70,6 @@
 info['surcharge'] = 300
 info['acceptance_fee'] = 20000
-info['amount'] = amount = info['acceptance_fee'] + info['surcharge']
-total_amount = 100*int(amount)
+info['amount'] = amount = info['acceptance_fee']
+total_amount = 100*(int(amount) + info['surcharge'])
 
 if student_id is None:
@@ -80,4 +80,5 @@
 
 info['action'] = "https://webpay.interswitchng.com/paydirect/webpay/pay.aspx"
+info['action'] = "https://testwebpay.interswitchng.com/test_paydirect/webpay/pay.aspx"
 
 if "payments" not in student.objectIds():
@@ -120,7 +121,4 @@
 
 
-interswitch_amount = 300
-fut_amount = amount - interswitch_amount
-
 xmldict = {}
 xmldict['detail_ref'] = args['txn_ref']
@@ -128,5 +126,5 @@
 xmldict['level'] = student_record.level
 xmldict['faculty'] = student_record.faculty
-xmldict['fut_amount'] = "%d" % int(100*fut_amount)
+xmldict['fut_amount'] = 100*amount
 
 
@@ -149,3 +147,3 @@
 info['args'] = args
 
-return context.goto_interswitch_form(info=info)
+return context.goto_interswitch_form_accept(info=info)